
#define BIOS_START_ADDRESS 0xE000 // E000 - FFF0
#define FIRST_COMMAND_OFFSET 0x010 // The copy_memory function should be skipped when the computer starts executing the bios from RAM
#define RAM_BIOS_LOCATION 0xD000 // 
#define BIOS_SIZE 0xFF0 




void copy_memory(void* source, void* destination, unsigned int size) @ 0xE000 {
    unsigned char* src = (unsigned char*)source;
    unsigned char* dest = (unsigned char*)destination;

    for (unsigned int i = 0; i < size; i++) {
        dest[i] = src[i];
    }
}

typedef void (*CodeExecutionFunction)();

void start_post() @ 0xE020 {
    return 0;
}

int main() {
    // copy bios to ram
    copy_memory((void*)BIOS_START_ADDRESS, (void*)RAM_BIOS_LOCATION, BIOS_SIZE);
    unsigned char* second_command_in_ram_bios = (unsigned char*)RAM_BIOS_LOCATION + FIRST_COMMAND_OFFSET;
    CodeExecutionFunction executeCopiedCode = (CodeExecutionFunction)second_command_in_ram_bios;
    executeCopiedCode();

    return 0;
}